//+------------------------------------------------------------------+
//| main sorting function                                            |
//+------------------------------------------------------------------+
void quickSort(string& A[],int low,int high)
	{
		string pivot, tmp;
		int    scan_forward, scan_back;
		int    middle;
		//---- if elements to sort less than 2 - return.
		if (high-low<=0)
			return(0);
		else
			if (high-low==1)
				{
					//---- if count of elements to sort equal to 2 swap it if need
					if (A[high]<A[low])
						{
							tmp=A[low];
							A[low]=A[high];
							A[high]=tmp;
						}
					return(0);
				}
		//---- calc middle element and store it in the pivot variable.
		middle=(low+high)/2;
		pivot=A[middle];
		//---- swap middle and first elements
		tmp=A[middle];
		A[middle]=A[low];
		A[low]=tmp;
		//---- initializing scan_up and scan_down indexes
		scan_forward=low+1;
		scan_back=high;
		//---- scan elements that places in opposite lists.
		while(scan_forward<scan_back)
			{
				//---- scan to forward. stop when crossing second list or current element greater than middle.
				while(scan_forward <= scan_back && A[scan_forward]<=pivot)
					scan_forward++;
				//---- scan to backward. stop when current element greater than or equal to middle.
 				while(A[scan_back]>pivot)
 					scan_back--;
				//---- if scan indexes not crossed they points to elements need to swap.
				if (scan_forward < scan_back)
					{
						tmp=A[scan_forward];
						A[scan_forward]=A[scan_back];
						A[scan_back]=tmp;
					}
			}
		//---- swdaTrigger first and dividing elements
		A[low] = A[scan_back];
		//---- swdaTrigger middle and dividing elements
		A[scan_back] = pivot;
		//---- if first sublist has 2 or more elements sort it's too
		if (low < scan_back-1)   quickSort(A, low, scan_back-1);
		//---- if second sublist has 2 or more elements sort it's too
		if (scan_back+1 < high)  quickSort(A, scan_back+1, high);
		//---- that's all
		return(0);
	}


